#ifndef SECTIONTOEXECUTE_SEEN
#define SECTIONTOEXECUTE_SEEN

#include "nomDeLogiciel.h"
#include "abstractElement.h"
#include "abstractSoftware.h"

class sectionToExecute
{
 public :
  /** Create a new sectionToExecute and initialize it with the given element
   */
  sectionToExecute(abstractElement*);

  /** Create a new sectionToExecute and initialize it with the given element and software
   */
  sectionToExecute(abstractElement*,abstractSoftware*);
  
  /** Deprecated : To be removed ! */
  sectionToExecute(abstractElement*, int, abstractElement*, int, abstractSoftware*);

  ~sectionToExecute() {;}

  inline abstractSoftware* getSoftware() const {
    return software_;
  }
  
  inline abstractSoftware* setSoftware(abstractSoftware* soft) {
    software_ = soft;
  }
  
  /**
   Get the vector of elements of this sector
   */
  inline std::vector< abstractElement* > getElements() {return elements_;};
  
  /**
   Get the last element of this section
   */
  inline abstractElement*  getLastElement() {return elements_.back();};
  
  /**
   Remove the last element of this section
   */
  inline void removeLastElement() {return elements_.pop_back();};

  bool insertAfter(abstractElement*,abstractElement*);

  private :

  abstractSoftware* software_;

  std::vector< abstractElement* > elements_;
};
#endif
