#ifndef GWT_Accelerator_SEEN
#define GWT_Accelerator_SEEN

#include <iostream>

#include <Wt/WContainerWidget>
#include <Wt/WScrollArea>
#include <Wt/WComboBox>
#include <Wt/WDialog>
#include <Wt/WPdfImage>
#include <Wt/Chart/WCartesianChart>
#include <Wt/WLength>

#include "dataManager.h"

#include "GWt_dialog.h"

using namespace Wt;

using namespace std;

class GWt_accelerator : public WContainerWidget
{
  
public:
  GWt_accelerator(WContainerWidget*, dataManager*);
  virtual ~GWt_accelerator();
  inline WContainerWidget* getAcceleratorDetailledView() {return acceleratorDetailledView_;};
  inline WLayout* getAcceleratorGlobalViewLayout() {return acceleratorGlobalViewLayout_;};
  inline dataManager* getDataManager() { return dataManager_;};
  void faireDessin();
  WContainerWidget* createDrawingWidget();

  private :
  WContainerWidget* acceleratorDetailledView_;
  void addSector();
  void run();
  void closeGraphicDialog();
  void dialogOnGraphics();
  void dessiner();
  void faireDessinPhaseSpace(WContainerWidget* toto, particleBeam* beam, string elementLabel, string namex, string namey, int typeFaisceau);
  void faireDessinEnveloppe(WContainerWidget* toto, string type);
  void dessinerEnveloppe();
  void dessinerPhaseSpace();
  void dessinerHistogramme();
  void chartPlot2vec(WContainerWidget* toto,vector<double>& xcor,vector<double>& ycor,Wt::Chart::SeriesType seriesType,Wt::Chart::FillRangeType fillRange,Wt::Chart::AxisValue value,bool isGridLinesEnables,string title,string legendx,string legendy,int width,int height,bool makeIcon = false);
  bool areDataCoherent();


  WLayout* acceleratorGlobalViewLayout_;
  dataManager* dataManager_;
  WComboBox* choixElementDessin_;
  WComboBox* choixTypeDessinFaisceau_;
  WComboBox* choixAbsPhase_;
  WComboBox* choixOrdPhase_;
  WComboBox* choixEnveloppeDessin_;
  WComboBox* choixHistoDessin_;
  WComboBox* choixVariableHisto_;
  GWt_dialog* graphicsDialog_;
  WButtonGroup *group_;
  vector<GWt_dialog*> eDialog_;
  WContainerWidget* toto_;
  string nameOfCase_;

};

#endif
