//
//  GWt_softwarePanel.h
//  PSPA
//
//  Created by Garnier Laurent on 30/01/13.
//  Copyright (c) 2013 Garnier Laurent. All rights reserved.
//

#ifndef GWt_softwarePanel_SEEN
#define GWt_softwarePanel_SEEN

#include <iostream>
#include <Wt/WContainerWidget>
#include <Wt/WPushButton>
#include "GWt_sectionToExecute.h"
#include "dataManager.h"

using namespace Wt;
using namespace std;

class PspaApplication;
class GWt_sector;

class GWt_softwarePanel  : public WContainerWidget
{
 public :
  
  GWt_softwarePanel(dataManager*, GWt_sector*);
  virtual ~GWt_softwarePanel();

  void displayFromControler();
  void updateSections();
    
 private :
 
  bool updateSectionSelection();
  void addSectionToExecute();
  void deleteSectionToExecute(int section);
  string getSelection();
  void fillComboWithElements(Wt::WComboBox* cBox);
  void fillComboWithSoftwares(Wt::WComboBox* cBox);
  Wt::WContainerWidget* createAddDeletePushButtons(int sectionIndex);

  dataManager* dtmanage_;
  WContainerWidget* contenuSections_;
  GWt_sector* UIsector_;

  std::vector <GWt_sectionToExecute*> UIsectionsToExecute_;
};
#endif /* defined(__PSPA__GWt_softwarePanel__) */
